package com.gct.common.core.entity;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.List;

@ApiModel(value="PageRequest", description="分页查询对象封装")
@Data
public class PageRequest {

	@ApiModelProperty(value = "当前页")
	private int pageNum = 1;

	@ApiModelProperty(value = "页大小")
	private int pageSize = 10;

	@ApiModelProperty(value = "查询参数 key：参数名，value：参数值，type：查询类型")
	private List<Param> queryParams;

    @ApiModelProperty(value = "排序参数 key：参数名，asc：是否正序")
    private List<Order> orders;

}
