package com.gct.common.core.result;

/**
 * @author: NewMeanning
 * @create: 2020-09-25 12:11
 **/
public enum CodeMsgEnum implements CodeMsgInterface {


    /**
     * 1,success,成功
     */
    SUCCESS(1, "success"),
    ADD_SUCCESS(1,"添加成功"),
    MODIFY_SUCCESS(1,"修改成功"),
    DELETE_SUCCESS(1,"删除成功"),
    /**
     * 2,fail,失败
     */
    FAIL(-1, "fail"),
    ADD_FAIL(-1,"添加失败"),
    MODIFY_FAIL(-1,"修改失败"),
    DELETE_FAIL(-1,"删除失败"),
    /**
     * 3,error,系统错误/程序异常
     */
    ERROR(0, "error"),
    /**
     * 100,missing parameter,参数缺失
     */
    MISSING_PARAMETER(100, "missing parameter"),
    /**
     * 101,paramenter type inconformity,参数类型不一致
     */
    PARAMENTER_TYPE_INCONFORMITY(101, "paramenter type inconformity"),
    /**
     * 102,parameter not valid,参数不合法
     */
    PARAMENTER_NOT_VALID(102, "parameter not valid");


    /**
     * 状态码
     */
    private int code;
    /**
     * 消息
     */
    private String msg;

    @Override
    public int getCode() {
        return this.code;
    }

    @Override
    public String getMsg() {
        return this.msg;
    }

    CodeMsgEnum(int code, String msg) {
        this.code = code;
        this.msg = msg;
    }
}
