package com.gct.common.core.shardingJDBC;

import org.springframework.stereotype.Component;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * annotation type: ShardingJDBCTable
 *
 * @author gxt
 * @version 1.0
 * @since 2021/10/12 下午5:36 周二
 */
@Target(ElementType.TYPE)
@Retention(RetentionPolicy.RUNTIME)
@Component
public @interface ShardingJDBCAnnotation {
    //属于那个数据库连接
    String dsNumValue() default "";
    //数据库名字
    String dataSourceNameValue() default "";
    //数据库的实例名
    String dataSourceNameValueForEx() default "";
    //分表的表名
    String tableNameValue() default "";
    //字段名字
    String cloumnNameValue() default "";
    //驱动
    String driverClassname() default "";
    //数据库连接
    String jdbcURL() default "";
    //用户名
    String userName() default "";
    //密码
    String passWord() default "";

}
