package com.gct.common.core.shardingJDBC;

import org.apache.shardingsphere.api.sharding.standard.PreciseShardingAlgorithm;
import org.apache.shardingsphere.api.sharding.standard.PreciseShardingValue;

import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.Collection;


/*
 * class name: TableShardingAlgorithmWithProdDate
 * @author gxt
 * @version 1.0
 * @since 2021/8/31 下午3:05 周二
*/
public class ShardingRuleWithBasic implements  PreciseShardingAlgorithm<LocalDateTime> {
    @Override
    public String doSharding(Collection<String> availableTargetNames, PreciseShardingValue<LocalDateTime> preciseShardingValue) {
       String[] date = preciseShardingValue.getValue().format(DateTimeFormatter.ofPattern("yyyy-MM-dd")).split("-");
       return "centralbase."+preciseShardingValue.getLogicTableName()+"_"+date[0]+date[1];
    }


}
