
package com.gct.common.core.shardingJDBC;

import com.google.common.collect.Range;
import org.apache.shardingsphere.api.sharding.standard.RangeShardingAlgorithm;
import org.apache.shardingsphere.api.sharding.standard.RangeShardingValue;

import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.Collection;


/**
 * class name: TableShardingRangeShardingAlgorithmWithProdDate
 *
 * @author gxt
 * @version 1.0
 * @since 2021/9/9 上午11:47 周四
 */
public class ShardingRuleWithRange implements RangeShardingAlgorithm<LocalDateTime> {
    @Override
    public Collection<String> doSharding(Collection<String> collection, RangeShardingValue<LocalDateTime> rangeShardingValue) {
        Collection<String> availables = new ArrayList<>();
        Range<LocalDateTime> valueRange = rangeShardingValue.getValueRange();
        for (String target : collection) {
            if (valueRange.hasLowerBound()){
                String lowerStr = valueRange.lowerEndpoint().toString();
                System.out.println(lowerStr);
                String[] split = lowerStr.split("-");
                String start = "centralbase."+target+"_"+split[0]+split[1];
                availables.add(start);
            }
            if (valueRange.hasUpperBound()){
                String upperStr = valueRange.upperEndpoint().toString();
                String[] split = upperStr.split("-");
                String end = "centralbase."+target +"_"+ split[0]+split[1];
                availables.add(end);
            }
        }
        return availables;
    }

}

