package com.gct.common.core.util;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.OrderItem;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.gct.common.core.entity.Order;
import com.gct.common.core.entity.PageRequest;
import com.gct.common.core.entity.Param;


import java.util.List;
import java.util.concurrent.atomic.AtomicBoolean;
import java.util.regex.Matcher;
import java.util.regex.Pattern;


/**
 *       へ　　　　　／|
 *  　　/＼7　　　 ∠＿/
 *  　 /　│　　 ／　／
 *  　│　Z ＿,＜　／　 /`ヽ
 *  　│　　　　　ヽ　 /　　〉
 * 　 Y　　　　　 \\ /　　/
 * 　ｲ ●　､　●　 ⊂⊃〈　　/
 * 　()　 へ　　　　|　＼〈
 * 　　>ｰ ､_　 ィ　 │ ／／
 * 　 / へ　　 /　ﾉ＜| ＼＼
 * 　 ヽ_ﾉ　　(_／　 │／／
 * 　　7　　　　　　　|／
 * 　　＞―r￣￣`ｰ―＿／\
 *  ————————————————  皮卡丘保佑无BUG!!!
 * mybatis-plus  分页查询公共代码抽取封装
 * @author: NewMeanning
 * @create: 2020-12-25 11:36
 **/
public class QueryUtil<T> {

    private static final Pattern humpPattern = Pattern.compile("[A-Z]");

    /**
     * 驼峰，转下换线，因为前端传来驼峰，而后端QueryWrapper 传的是数据库字段
     * @param str
     * @return
     */
    public String humpToLine(String str) {
        Matcher matcher = humpPattern.matcher(str);
        StringBuffer sb = new StringBuffer();
        while (matcher.find()) {
            matcher.appendReplacement(sb, "_" + matcher.group(0).toLowerCase());
        }
        matcher.appendTail(sb);
        return sb.toString();
    }


    /**
     * 设置page
     * @param pageRequest
     * @return
     */
    public Page<T> setPage(PageRequest pageRequest){
        return this.setPage(pageRequest,null);
    }

    /**
     * 设置page + 自定义排序
     * @param pageRequest
     * @param orderItemList
     * @return
     */
    public Page<T> setPage(PageRequest pageRequest, List<OrderItem> orderItemList){
        //前端从1开始 后端从0开始分页，这里需要减一
        Page<T> page = new Page<>(pageRequest.getPageNum()-1,pageRequest.getPageSize());
        List<Order> orders = pageRequest.getOrders();
        //TODO 排序字段处理
        return page;
    }

    /**
     * 设置queryWrapper
     * @param pageRequest
     * @return
     */
    public QueryWrapper<T> setQueryWrapper(PageRequest pageRequest) throws Exception{
        //类型是否存在标志；
        AtomicBoolean typeExistence = new AtomicBoolean(true);
        //附加查询条件，默认eq
        List<Param> params = pageRequest.getQueryParams();
        QueryWrapper<T> queryWrapper = new QueryWrapper<>();   //创建查询queryWrapper
        if(params!=null && params.size()>0){
            params.stream().forEach((param) -> {
                String type = param.getType();
                switch (type){
                    case "eq":queryWrapper.eq(humpToLine(param.getKey()),param.getValue());break;
                    case "like":queryWrapper.like(humpToLine(param.getKey()),param.getValue());break;
                    case "lt":queryWrapper.lt(humpToLine(param.getKey()),param.getValue());break;
                    case "gt":queryWrapper.gt(humpToLine(param.getKey()),param.getValue());break;
                    default: typeExistence.set(false);
                }
            });
        }
        if(!typeExistence.get()){
            throw new Exception("非法查询类型！(╯‵□′)╯︵┻━┻ 走你！");
        }
        return queryWrapper;
    }

}
