package com.gct.common.security.annotation;

import com.gct.common.security.config.GCTCacheSecurityCheckConfig;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.Import;

import java.lang.annotation.Documented;
import java.lang.annotation.Retention;
import java.lang.annotation.Target;

/**
 * Annotation name: EnableGCTCacheSecurityCheck
 *
 * @author lloyd
 * @version 1.0
 * @since 2021/5/8 下午2:02
 */
@Retention(value = java.lang.annotation.RetentionPolicy.RUNTIME)
@Target(value = {java.lang.annotation.ElementType.TYPE})
@Documented
@Import({GCTCacheSecurityCheckConfig.class})
@Configuration
public @interface EnableGCTCacheSecurityCheck {
    /**
     * set debug config ,default is false;
     * @return
     */
    boolean debug() default false;
}
