package com.gct.common.security.annotation;

import com.gct.common.security.config.RedisClientConfigProperties;
import com.gct.common.security.config.GCTRedisCacheConfig;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.Import;

import java.lang.annotation.Documented;
import java.lang.annotation.Retention;
import java.lang.annotation.Target;

/**
 * Annotation name: EnableGCTRedisConfig
 *
 * @author lloyd
 * @version 1.0
 * @since 2021/5/7 上午10:24
 */
@Retention(value = java.lang.annotation.RetentionPolicy.RUNTIME)
@Target(value = {java.lang.annotation.ElementType.TYPE})
@Documented
@Import({GCTRedisCacheConfig.class})
@Configuration
public @interface EnableGCTRedisCacheConfig {
}
