package com.gct.common.security.annotation;

import com.gct.common.security.config.GCTCacheSecurityCheckConfig;
import com.gct.common.security.config.WebSecurityConfigProperties;
import com.gct.common.security.config.GCTServiceSecurityConfig;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.Import;

import java.lang.annotation.Documented;
import java.lang.annotation.Retention;
import java.lang.annotation.Target;

/**
 * Annotation name: EnableGCTWebSecurity
 *
 * @author lloyd
 * @version 1.0
 * @since 2021/5/7 上午10:08
 */
@Retention(value = java.lang.annotation.RetentionPolicy.RUNTIME)
@Target(value = {java.lang.annotation.ElementType.TYPE})
@Documented
@Import({GCTServiceSecurityConfig.class})
@Configuration
public @interface EnableGCTServiceSecurity {
    boolean debug() default false;
}
