package com.gct.common.security.config;

import com.gct.common.security.annotation.EnableGCTRedisCacheConfig;
import com.gct.common.security.core.CheckTokenCaching;
import com.gct.common.security.core.DefaultCheckTokenCaching;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.data.redis.core.RedisTemplate;

/**
 * class name: GCTWebSecurityConfig
 *
 * @author lloyd
 * @version 1.0
 * @since 2021/5/7 上午10:12
 */
@Configuration
@EnableGCTRedisCacheConfig
public class GCTCacheSecurityCheckConfig {

    @Bean(name="DefaultCheckTokenCaching")
    public CheckTokenCaching checkTokenCaching(RedisTemplate redisTemplate){
        return new DefaultCheckTokenCaching(redisTemplate);
    }
}
