package com.gct.common.security.config;

import lombok.Data;
import lombok.experimental.Accessors;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.context.properties.ConfigurationProperties;

/**
 * class name: RedisConfigProperties
 *
 * @author lloyd
 * @version 1.0
 * @since 2021/5/7 下午3:50
 */
@ConfigurationProperties(prefix = "spring.redis")
@Data
@Accessors(chain = true)
public class RedisClientConfigProperties {
    private int database=0;

    private String host="127.0.0.1";

    private String password;

    private int port=6379;

    private int timeout=100;



}
@ConfigurationProperties(prefix = "spring.redis.jedis.pool")
@Data
@Accessors(chain = true)
class RedisClientJedisPoolProperties{
//    @Value("${spring.redis.jedis.pool.max-idle}")
    private int maxIdle=8;

//    @Value("${spring.redis.jedis.pool.min-idle}")
    private int minIdle=0;

    /*   @Value("${jedis.pool.max-active}")
       private int maxActive;*/
//    @Value("${spring.redis.jedis.pool.max-total}")
    private int maxTotal=8;
//    @Value("${spring.redis.jedis.pool.max-wait}")
    private long maxWait=-1;
}
