package com.gct.common.security.core;


import com.gct.common.security.util.SecurityUtils;
import org.springframework.security.authentication.AuthenticationManager;
import org.springframework.security.web.authentication.www.BasicAuthenticationFilter;

import javax.servlet.FilterChain;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

/**
 * 登录认证过滤器
 * @author NewMeanning
 * @since  2020-12-26
 */
public final class JwtAuthenticationFilter extends BasicAuthenticationFilter {

    CheckTokenCaching checkTokenCaching;

    public JwtAuthenticationFilter(AuthenticationManager authenticationManager) {
        super(authenticationManager);
    }
    public JwtAuthenticationFilter(AuthenticationManager authenticationManager,CheckTokenCaching checkTokenCaching){
        this(authenticationManager);
        this.checkTokenCaching=checkTokenCaching;
    }

    @Override
    protected void doFilterInternal(HttpServletRequest request, HttpServletResponse response, FilterChain chain) throws IOException, ServletException {
    	// 获取token, 并检查登录状态
        SecurityUtils.checkAuthentication(request,this.checkTokenCaching);
        chain.doFilter(request, response);
    }
    
}