package com.gct.common.util;

import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.LocalTime;
import java.time.format.DateTimeFormatter;

public class DateTimeUtil {

    public static DateTimeFormatter GCT_DATE_TIME = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");
    public static DateTimeFormatter GCT_DATE = DateTimeFormatter.ofPattern("yyyy-MM-dd");
    public static DateTimeFormatter GCT_TIME = DateTimeFormatter.ofPattern("HH:mm:ss");

    public static String formatString(LocalDateTime dateTime) {
        if (dateTime != null) return dateTime.format(GCT_DATE_TIME);
        return null;
    }

    public static String formatString(LocalDate date) {
        if (date != null) return date.format(GCT_DATE);
        return null;
    }

    public static String formatString(LocalTime time) {
        if (time != null) return time.format(GCT_TIME);
        return null;
    }

    public static String formatDateStr(LocalDateTime dateTime) {
        if (dateTime == null) return null;
        return dateTime.format(GCT_DATE);
    }

    public static String formatTimeStr(LocalDateTime dateTime) {
        if (dateTime == null) return null;
        return dateTime.format(GCT_TIME);
    }

    public static LocalDateTime formatDateTime(String str) {
        if (StringUtil.isBlankOrEmpty(str)) return null;
        return LocalDateTime.parse(str, GCT_DATE_TIME);
    }

    public static LocalTime formatTime(String str) {
        if (StringUtil.isBlankOrEmpty(str)) return null;
        return LocalTime.parse(str, GCT_TIME);
    }

    public static LocalDate formatDate(String str) {
        if (StringUtil.isBlankOrEmpty(str)) return null;
        return LocalDate.parse(str, GCT_DATE);
    }

    public static LocalDateTime dateToDateTime(LocalDate date) {
        if (date == null) return null;
        return LocalDateTime.parse(date.format(GCT_DATE) + " 00:00:00", GCT_DATE_TIME);
    }

    public static LocalDateTime mergeToDateTime(LocalDate date, LocalTime time) {
        if (date == null || time == null) return null;
        return LocalDateTime.parse(date.format(GCT_DATE) + " " + time.format(GCT_TIME), GCT_DATE_TIME);
    }

    public static LocalDate getDateFromDateTime(LocalDateTime dateTime) {
        String s = formatDateStr(dateTime);
        if (StringUtil.isBlankOrEmpty(s)) return null;
        return LocalDate.parse(s, GCT_DATE);
    }

    public static LocalTime getTimeFromDateTime(LocalDateTime dateTime) {
        String s = formatTimeStr(dateTime);
        if (StringUtil.isBlankOrEmpty(s)) return null;
        return LocalTime.parse(s, GCT_TIME);
    }
}
